"""__init__ for dataclocklib package.

NOTE:  We generate __version__ from the 'dataclocklib' package information,
facilitated by 'setuptools_scm'.

Author: Andrew Ridyard.

License: GNU General Public License v3 or later.

Copyright (C): 2025.

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <https://www.gnu.org/licenses/>.
"""

from importlib.metadata import PackageNotFoundError, version

from dataclocklib.charts import dataclock, line_chart

try:
    __version__ = version("dataclocklib")
except PackageNotFoundError:
    pass

__all__ = ("dataclock", "line_chart")
